%--------------------------------------------------------------------------
% Get chromaticity diagram coordinate by Color Temperature
% T >= 2000 K and T <=50000 K
%--------------------------------------------------------------------------
function [T,Tint]=GetColorTemperature(u,v)
%--------------------------------------------------------------------------
% clear all;
% T=50000;Tint=-150;
% [xx,yy,u,v]=GetColorTemperatureCoord(T,Tint);
%--------------------------------------------------------------------------
load('DataTable.mat','PlanckianLocusMired');
Table=PlanckianLocusMired;
up=Table.u';vp=Table.v';xp=Table.x';yp=Table.y';
slopep=Table.slope';pmired=Table.Mired';
distance=((v-vp)-slopep.*(u-up))./power(1+power(slopep,2),1/2);
for n=1:length(Table.u)-1
    if sign(distance(n))~=sign(distance(n+1))
        break;
    end
end
if n==length(Table.u)-1 
    if abs(distance(1))<abs(distance(n))
        n=1;
    end
end
m1=pmired(n);m2=pmired(n+1);slope1=slopep(n);slope2=slopep(n+1);
u1=up(n);u2=up(n+1);v1=vp(n);v2=vp(n+1);
d1=abs(((v1-v)-slope1*(u1-u))/power(1+power(slope1,2),1/2));
d2=abs(((v2-v)-slope2*(u2-u))/power(1+power(slope2,2),1/2));
m=m2*d1/(d1+d2)+m1*d2/(d1+d2);
ui=u2*d1/(d1+d2)+u1*d2/(d1+d2);
vi=v2*d1/(d1+d2)+v1*d2/(d1+d2);
tintdistance=GetDistance([u;v;1-u-v],[ui;vi;1-ui-vi])*sign(v-vi);
between=GetDistance([u1;v1;1-u1-v1],[u2;v2;1-u2-v2]);
tintmiredscale=abs(m1-m2)/between;
Tint=round(tintdistance*tintmiredscale);
T=round(1e6/m);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
