%--------------------------------------------------------------------------
% Get Color Temperature Coordinate by T, Tint
%--------------------------------------------------------------------------
function [x,y,u,v]=GetColorTemperatureCoord(T,Tint)
%--------------------------------------------------------------------------
% clear all;
% T=4977;Tint=-10;
%--------------------------------------------------------------------------
if T<2000 | T>50000 | Tint>150 | Tint<-150
    disp('Color Temperture over the scope');
else
    load('DataTable.mat',...
        'PlanckianLocusTemperature','PlanckianLocusMired');
    n=T-2000+1;
    x1=PlanckianLocusTemperature.x(n);
    y1=PlanckianLocusTemperature.y(n);
    u1=PlanckianLocusTemperature.u(n);
    v1=PlanckianLocusTemperature.v(n);
    m1=PlanckianLocusTemperature.Mired(n);
    slope1=PlanckianLocusTemperature.slope(n);
    if T==50000
        u2=PlanckianLocusTemperature.u(n-1);
        v2=PlanckianLocusTemperature.v(n-1);
        m2=PlanckianLocusTemperature.Mired(n-1);
        slope2=PlanckianLocusTemperature.slope(n-1);
    else
        u2=PlanckianLocusTemperature.u(n+1);
        v2=PlanckianLocusTemperature.v(n+1);
        m2=PlanckianLocusTemperature.Mired(n+1);
        slope2=PlanckianLocusTemperature.slope(n+1);
    end
    k=-(u1-u2)/(v1-v2);
    scale=power(power(u1-u2,2)+power(v1-v2,2),1/2)/abs(m1-m2);
    du=cos(atan(slope1))*scale*(-Tint);
    dv=sin(atan(slope1))*scale*(-Tint);
    u=u1+du;
    v=v1+dv;
    k=(v-v1)/(u-u1);
    [x,y]=uv2xy(u,v);
%     [AT,ATint]=RawColorTemperature(u,v);
end
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
