%--------------------------------------------------------------------------
function [R,G,B]=GetForecastColor(R,G,B,mode,RgbMax)
%--------------------------------------------------------------------------
% clear all;
% CameraNeutral=[0.5356;1;0.5845];
% RgbMax=CameraNeutral;
% ImageRawCamera=[...
%     0.5356,0.5800,0.0000,0.4,1.0,0.3,0.4,0.4,0.6,0.6,0.6,1.0,1.0;...
%     0.0000,1.0000,0.0000,0.4,0.4,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0;...
%     0.0000,0.3300,0.5845,0.4,1.0,0.4,0.7,1.0,0.5,0.7,1.0,0.8,1.0];
% % ApexRgb=[CameraNeutral(1),0,0,CameraNeutral(1);...
% %         0,CameraNeutral(2),0,0;0,0,CameraNeutral(3),0];
% % R=ApexRgb(1,1);G=ApexRgb(2,1);B=ApexRgb(3,1);
% R=ImageRawCamera(1,:);G=ImageRawCamera(2,:);B=ImageRawCamera(3,:);;
% mode='Red';
%--------------------------------------------------------------------------
clipping=(4095-5)/4095;scale=1.0;overif=1;
switch mode
    case 'More'
        Gr=R*RgbMax(2)/RgbMax(1);Gb=B*RgbMax(2)/RgbMax(3);
        Gt=(Gr+Gb)/2;
        if overif==1
            mask=Gt>G;
            G=G.*double(~mask)+Gt.*double(mask);
        else
            G=Gt;
        end
%         R=R*0;G=G*0;B=B*0;
    case 'RedClipping'
        Gb=B*RgbMax(2)/RgbMax(3);Rb=B*RgbMax(1)/RgbMax(3);
        Gr=R*RgbMax(2)/RgbMax(1);Rr=R;
        Gt=(Gr+Gb)/2;Rt=(Rr+Rb)/2;
        if overif==1
            mask=Gt>G;
            G=G.*double(~mask)+Gt.*double(mask);
            mask=Rt>R;
            R=R.*double(~mask)+Rt.*double(mask);
        else
            G=Gt;R=Rt;
        end
%         R=R*0;G=G*0;B=B*0;
    case 'BlueClipping'
        Gr=R*RgbMax(2)/RgbMax(1);Br=R*RgbMax(3)/RgbMax(1);
        Gb=B*RgbMax(2)/RgbMax(3);Bb=B;
        Gt=(Gr+Gb)/2;Bt=(Br+Bb)/2;
        if overif==1
            mask=Gt>G;
            G=G.*double(~mask)+Gt.*double(mask);
            mask=Bt>B;
            B=B.*double(~mask)+Bt.*double(mask);
        else
            G=Gt;B=Bt;
        end
%         R=R*0;G=G*0;B=B*0;
    case 'Clipping'
        Gr=R*RgbMax(2)/RgbMax(1);Br=R*RgbMax(3)/RgbMax(1);Rr=R;
        Gb=B*RgbMax(2)/RgbMax(3);Bb=B;Rb=B*RgbMax(1)/RgbMax(3);
        Gt=(Gr+Gb)/2;Bt=(Br+Bb)/2;Rt=(Rr+Rb)/2;
        Gc=scale*RgbMax(2)/RgbMax(1);
        Bc=scale*RgbMax(3)/RgbMax(1);
        Rc=scale*clipping;
        mask=R>=clipping & G>=clipping & B>=clipping;
        Gt=Gt.*double(~mask)+Gc.*double(mask);
        Bt=Bt.*double(~mask)+Bc.*double(mask);
        Rt=Rt.*double(~mask)+Rc.*double(mask);
        if overif==1
            mask=Gt>G;
            G=G.*double(~mask)+Gt.*double(mask);
            mask=Bt>B;
            B=B.*double(~mask)+Bt.*double(mask);
            mask=Rt>R;
            R=R.*double(~mask)+Rt.*double(mask);
        else
            G=Gt;B=Bt;R=Rt;
        end
%         R=R*0;G=G*0;B=B*0;
    otherwise %'Undo'
end
% A=[R;G;B];
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
