%--------------------------------------------------------------------------
% Function: [Calibration Illuminant] =>[x,y,z]
% Convert calibration illuminant to chromaticity coordinate
%--------------------------------------------------------------------------
function [T,Tint,Mired]=GetIlluminantCoord(CalibrationIlluminant)
%--------------------------------------------------------------------------
switch CalibrationIlluminant
    case 24
        x=0.44758;y=0.40745;
    case 17 % Standard light A
        x=0.44758;y=0.40745;
    case 18 % Standard light B
        x=0.3484;y=0.3516;
    case 19 % Standard light C
        x=0.3101;y=0.3162;
    case 20 % D55
        x=0.33243;y=0.34744;
    case 21 % D65
        x=0.31272;y=0.32903;
    case 22 % D75
        x=0.29903;y=0.31488;
    case 23 % D50
        x=0.34567;y=0.35851;
%     case 1  % Daylight
%     case 2  % Fluorescent
%     case 3  % Tungsten(incandescent light)
%     case 4  % Flash
%     case 9  % Fine weather
%     case 10 % Cloudy weather
%     case 11 % Shade
%     case 12 % Daylight fluorescent(D 5700 - 7100K)
%     case 13 % Day white fluorescent(N 4600 - 5400K)
%     case 14 % Cool white fluorescent(W 3900 - 4500K)
%     case 15 % White fluorescent(WW 3200 - 3700K)
%     case 24 % ISO studio tungsten
%     case 255 % other light source
    otherwise
        disp('Unknown Calibration Illuminant');
end
[u,v]=xy2uv(x,y);
[T,Tint]=GetColorTemperature(u,v);
Mired=1e6/T;
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
