%--------------------------------------------------------------------------
% Get Neutral Point, used by White Balance Calculate
%--------------------------------------------------------------------------
function GetXyzNeutral=GetNeutralGrayReflect(ImageXyzRaw)
%--------------------------------------------------------------------------
% clear all;
% load('ImageXyzRaw.mat','ImageXyzRaw');
% load('rawdecode.mat','AsShotXyzNeutral');
%--------------------------------------------------------------------------
load('rawdecode.mat','AsShotXyzNeutral');
load('DataTable.mat','IlluminantTable');

xyz=GetChromCoord(AsShotXyzNeutral);
[uShotNeutral,vShotNeutral]=xy2uv(xyz(1),xyz(2));

ImageXyzRaw=max(ImageXyzRaw,0);
YImage=ImageXyzRaw(2,:);
Pixels=length(YImage);
xyz=GetChromCoord(ImageXyzRaw);
[u,v]=xy2uv(xyz(1,:),xyz(2,:));
uMeanGray=mean(u);vMeanGray=mean(v);

Iteration=20;
tmax=1;tmin=0;tlevel=(tmax-tmin)/2;
valused=10/100;threshold=valused*0.001;
for m=1:Iteration
    MaskLight=YImage>=tlevel;
    tval=sum(double(MaskLight))/Pixels;
    if tval>=(valused-threshold) && tval<=(valused+threshold)
        break;
    elseif tval>(valused+threshold)
        tmin=tlevel;
        tlevel=tlevel+(tmax-tmin)/2;
    else
        tmax=tlevel;
        tlevel=tlevel-(tmax-tmin)/2;
    end
end
IterLight=[tval*100;tlevel;m];
uMask=u.*double(MaskLight);
vMask=v.*double(MaskLight);
MaskSize=sum(double(MaskLight));
uMeanReflect=mean(uMask)*Pixels/MaskSize;
vMeanReflect=mean(vMask)*Pixels/MaskSize;

uMean=uMeanReflect;vMean=vMeanReflect;
% uMean=uMeanGray;vMean=vMeanGray;

IllumNums=length(IlluminantTable.u);
Weight=power(power(IlluminantTable.u-uMean,2)...
    +power(IlluminantTable.v-vMean,2),1/2);
MinIllum=1.0;uNeutral=0.20916;vNeutral=0.48808/1.5;
for m=1:IllumNums
    if Weight(m)<MinIllum
        MinIllum=Weight(m);
        uNeutral=IlluminantTable.u(m);vNeutral=IlluminantTable.v(m);
    end
end

% %--------------------------------------------------------------------------
% CalibrationIlluminant=21;   % 17 - 21
% [T,Tint,Mired]=GetIlluminantCoord(CalibrationIlluminant);
% % T=2000;Tint=150;
% [x,y,uNeutral,vNeutral]=GetColorTemperatureCoord(T,Tint);
% %--------------------------------------------------------------------------

GetUcsNeutral=[uNeutral;vNeutral];
[xNeutral,yNeutral]=uv2xy(uNeutral,vNeutral);
[GetT,GetTint]=GetColorTemperature(uNeutral,vNeutral);

YNeutral=1.0;
XNeutral=YNeutral*xNeutral/yNeutral;
ZNeutral=YNeutral*(1-xNeutral-yNeutral)/yNeutral;
GetXyzNeutral=[XNeutral;YNeutral;ZNeutral];

% [CameraNeutral,XYZtoCamera]=MatXYZtoCamera(GetXyzNeutral);
% CameraNeutral=CameraNeutral/max(CameraNeutral);
% [XyzNeutral,CameraToXYZ]=MatCameraToXYZ(CameraNeutral);

% StructGetNeutralGrayReflect=struct(...
%     'GetUcsNeutral',GetUcsNeutral,'GetXyzNeutral',GetXyzNeutral,...
%     'GetT',GetT,'GetTint',GetTint,...
%     'XyzNeutral',XyzNeutral,'CameraNeutral',CameraNeutral,...
%     'XYZtoCamera',XYZtoCamera,'CameraToXYZ',CameraToXYZ);
% save('rawdecode.mat','XyzNeutral','CameraNeutral',...
%     'StructGetNeutralGrayReflect','-append');

StructGetNeutralGrayReflect.GetUcsNeutral=GetUcsNeutral;
StructGetNeutralGrayReflect.GetXyzNeutral=GetXyzNeutral;
StructGetNeutralGrayReflect.GetT=GetT;
StructGetNeutralGrayReflect.GetTint=GetTint;
save('rawdecode.mat','StructGetNeutralGrayReflect','-append');

uvData=[u;v];
Apex(1).val=[uShotNeutral;vShotNeutral];
Apex(1).color=[1,1,1];Apex(1).point='*';Apex(1).style=2;
Apex(2).val=[uNeutral;vNeutral];
Apex(2).color=[1,0,0];Apex(2).point='o';Apex(2).style=2;
Apex(3).val=[uMeanGray;vMeanGray];
Apex(3).color=[1,1,1];Apex(3).point='x';Apex(3).style=2;
MatUcsChromDiagram(uvData,Apex,'Gray World Point',0);

uvData=[uMask;vMask];
Apex(1).val=[uShotNeutral;vShotNeutral];
Apex(1).color=[1,1,1];Apex(1).point='*';Apex(1).style=2;
Apex(2).val=[uNeutral;vNeutral];
Apex(2).color=[1,0,0];Apex(2).point='o';Apex(2).style=2;
Apex(3).val=[uMeanReflect;vMeanReflect];
Apex(3).color=[1,1,1];Apex(3).point='+';Apex(3).style=2;
MatUcsChromDiagram(uvData,Apex,'Prefect Reflect Point',1);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
