%--------------------------------------------------------------------------
% Get Neutral Point, used by White Balance Calculate
%--------------------------------------------------------------------------
function GetXyzNeutral=GetUcsNeutral(ImageXyz)
%--------------------------------------------------------------------------
% clear all;
% load('ImageXyz.mat','ImageXyz');
% 
load('rawdecode.mat','RawStruct','XYZ_D50toCamera','XyzNeutral');
load('DataTable.mat','UcsChromDiagram','IlluminantTable',...
    'ProPhotoDiagram');
xyzImage=GetChromCoord(ImageXyz);
[uImage,vImage]=xy2uv(xyzImage(1,:),xyzImage(2,:));
uMean=mean(uImage);vMean=mean(vImage);

IllumNums=length(IlluminantTable.u);
Weight=power(power(IlluminantTable.u-uMean,2)...
    +power(IlluminantTable.v-vMean,2),1/2);
MinIllum=1.0;uNeutral=0.20916;vNeutral=0.48808/1.5;
for m=1:IllumNums
    if Weight(m)<MinIllum
        MinIllum=Weight(m);
        uNeutral=IlluminantTable.u(m);vNeutral=IlluminantTable.v(m);
    end
end

xyzNeutral=GetChromCoord(XyzNeutral);
[uShotNeutral,vShotNeutral]=xy2uv(xyzNeutral(1),xyzNeutral(2));

% PhotoWidth=RawStruct.DefaultCropSize(1)/2;
% PhotoHeight=RawStruct.DefaultCropSize(2)/2;
% ZoneWidthNums=40;
% ZoneHeightNums=30;
% ZoneNums=ZoneWidthNums*ZoneHeightNums;
% ZoneWidth=floor(PhotoWidth/ZoneWidthNums);
% ZoneHeight=floor(PhotoHeight/ZoneHeightNums);
% ZonePixels=ZoneWidth*ZoneHeight;
% 
% uPhoto(:,:)=reshape(uImage,PhotoWidth,PhotoHeight)';
% vPhoto(:,:)=reshape(vImage,PhotoWidth,PhotoHeight)';
% 
% uZone=zeros(ZoneNums,ZonePixels);
% vZone=zeros(ZoneNums,ZonePixels);
% for h=1:ZoneHeightNums
%     for w=1:ZoneWidthNums
%         n=(h-1)*ZoneWidthNums+w;
%         row=(h-1)*ZoneHeight+1;
%         col=(w-1)*ZoneWidth+1;       
%         uZone(n,:)=...
%             reshape(uPhoto(row:row+ZoneHeight-1,col:col+ZoneWidth-1)',...
%             1,ZonePixels);
%         vZone(n,:)=...
%             reshape(vPhoto(row:row+ZoneHeight-1,col:col+ZoneWidth-1)',...
%             1,ZonePixels);
%     end
% end
% 
% MuZone=mean(uZone,2);
% MvZone=mean(vZone,2);
% IllumNums=length(IlluminantTable.u);
% IllumData=zeros(1,IllumNums);
% MinIllum=1;
% for m=1:IllumNums
% %     Weight=sum(power(MuZone-IlluminantTable.u(m),2)...
% %         +power(MvZone-IlluminantTable.v(m),2))/ZoneNums;
%     Weight=sum(power(power(MuZone-IlluminantTable.u(m),2)...
%         +power(MvZone-IlluminantTable.v(m),2),1/2))/ZoneNums;
%     if Weight<MinIllum
%         MinIllum=Weight;
%         uNeutral=IlluminantTable.u(m);vNeutral=IlluminantTable.v(m);
%     end
% end

GetUcsNeutral=[uNeutral;vNeutral];
[xNeutral,yNeutral]=uv2xy(uNeutral,vNeutral);
[GetT,GetTint]=...
    RawColorTemperature([xNeutral,yNeutral,1-xNeutral-yNeutral]);
%YNeutral=XyzNeutral(2);
YNeutral=1.0;
XNeutral=YNeutral*xNeutral/yNeutral;
ZNeutral=YNeutral*(1-xNeutral-yNeutral)/yNeutral;
GetXyzNeutral=[XNeutral;YNeutral;ZNeutral];
save('rawdecode.mat',...
    'GetUcsNeutral','GetXyzNeutral','GetT','GetTint','-append');

figure(1);
plot(uImage,vImage,'.','color',[0,0,1]);
hold on
plot(IlluminantTable.u,IlluminantTable.v,'.','color',[0.0,0.1,0.8]);
plot(uShotNeutral,vShotNeutral,'*','color',[1,1,1]);
plot(uNeutral,vNeutral,'o','color',[1,0,0]);
plot(uMean,vMean,'x','color',[1,1,1]);
%--------------------------------------------------------------------------
uucs=1:length(UcsChromDiagram.vMax);
plot(uucs/1000,UcsChromDiagram.vMax,'color',[0.7,0.7,0.7]);
plot(uucs/1000,UcsChromDiagram.vMin,'color',[0.7,0.7,0.7]);
plot(ProPhotoDiagram.u,ProPhotoDiagram.v,'color',[0.7,0.7,0.7]);
%--------------------------------------------------------------------------
hold off
title('Image - UCS(u,v)');

% figure(2);
% plot(uImage,vImage,'.','color',[0,0,1]);
% hold on
% plot(IlluminantTable.u,IlluminantTable.v,'.','color',[0.0,0.1,0.8]);
% for n=1:ZoneNums
%     plot(MuZone(n),MvZone(n),'o','color',[0,1,0]);
% end
% plot(uShotNeutral,vShotNeutral,'*','color',[1,1,1]);
% plot(uNeutral,vNeutral,'o','color',[1,0,0]);
% % plot(uMeam,vMeam,'*','color',[1,1,1]);
% %--------------------------------------------------------------------------
% uucs=1:length(UcsChromDiagram.vMax);
% plot(uucs/1000,UcsChromDiagram.vMax,'color',[0.7,0.7,0.7]);
% plot(uucs/1000,UcsChromDiagram.vMin,'color',[0.7,0.7,0.7]);
% plot(ProPhotoDiagram.u,ProPhotoDiagram.v,'color',[0.7,0.7,0.7]);
% %--------------------------------------------------------------------------
% hold off
% title('Mean - UCS(u,v)');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
