%--------------------------------------------------------------------------
% Function: [CI1,CI2,XYZ] =>[Weight factor]
% Get weight factor
%--------------------------------------------------------------------------
function WeightFactor=GetWeightFactor(CI1,CI2,xyz)
%--------------------------------------------------------------------------
[T1,Tint1,Mired1]=GetIlluminantCoord(CI1);
[T2,Tint2,Mired2]=GetIlluminantCoord(CI2);
[u,v]=xy2uv(xyz(1),xyz(2));
[T,Tint]=GetColorTemperature(u,v);
Mired=1e6/T;
if Mired>=Mired1
    WeightFactor(1)=1;WeightFactor(2)=0;
elseif Mired<=Mired2
    WeightFactor(1)=0;WeightFactor(2)=1;
else
    WeightFactor(1)=(Mired-Mired2)/(Mired1-Mired2);
    WeightFactor(2)=(Mired1-Mired)/(Mired1-Mired2);
end
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
