%--------------------------------------------------------------------------
% Mapping Hsv Data Table
%--------------------------------------------------------------------------
function ImageHsv=MatHsvLookup(ImageHsv,...
    HsvCalibration,HueDivs,SaturationDivs,ValueDivs)
%--------------------------------------------------------------------------
H=1;S=2;V=3;
ImageHsv(H,:)=mod(ImageHsv(H,:),360);
ImageHsv(S,:)=min(ImageHsv(S,:),1.0);ImageHsv(S,:)=max(ImageHsv(S,:),0);
ImageHsv(V,:)=min(ImageHsv(V,:),1.0);ImageHsv(V,:)=max(ImageHsv(V,:),0);
LookupIndex=...
    min(floor(ImageHsv(V,:)*ValueDivs),ValueDivs-1)*HueDivs*SaturationDivs...
    +min(floor(ImageHsv(H,:)/360*HueDivs),HueDivs-1)*SaturationDivs...
    +min(floor(ImageHsv(S,:)*SaturationDivs),SaturationDivs-1)...
    +1;
ImageHsv(H,:)=ImageHsv(H,:)+HsvCalibration(H,LookupIndex);
ImageHsv(S,:)=ImageHsv(S,:).*HsvCalibration(S,LookupIndex);
ImageHsv(V,:)=ImageHsv(V,:).*HsvCalibration(V,LookupIndex);
clear LookupIndex;
ImageHsv(H,:)=mod(ImageHsv(H,:),360);
ImageHsv(S,:)=min(ImageHsv(S,:),1.0);ImageHsv(S,:)=max(ImageHsv(S,:),0);
ImageHsv(V,:)=min(ImageHsv(V,:),1.0);ImageHsv(V,:)=max(ImageHsv(V,:),0);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
