%--------------------------------------------------------------------------
% Draw Raw Histogram, PhotoData(row,col,n) 
% n: 0-RED, 1-GREEN1, 2-GREEN2, 3-BLUE, 4-LIGHT
%--------------------------------------------------------------------------
function HistData=MatImageHistRaw(PhotoData,WidthCentre,WidthScale)
%--------------------------------------------------------------------------
load('rawdecode.mat','FileName','BlackLevel','WhiteLevel');
load('rawconfig.mat','FigSequence');
%--------------------------------------------------------------------------
% Draw RAW data RGGB histogram
%--------------------------------------------------------------------------
drawcolor=char('r','g','g','b');
drawtitle=char('RED','GREEN1','GREEN2','BLUE');
conststr='\fontsize{20}\color[rgb]{.7 .7 .7}';
RawBitNum=round(log10(WhiteLevel)/log10(2));
%--------------------------------------------------------------------------
% Change '_' to '\_'
m=1;
for n=1:size(FileName,2)
    if FileName(n)=='_'
        strfile(m)='\';strfile(m+1)='_';
        m=m+2;
    else
        strfile(m)=FileName(n);
        m=m+1;
    end
end
drawfile=strcat(conststr,strfile);
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% Histogram
PhotoData=max(PhotoData,0);
PhotoData=round(PhotoData);
HistData=zeros(2^RawBitNum,4);
for n=1:4
    figure(FigSequence)
    FigSequence=FigSequence+1;
    pr=PhotoData(:,:,n);
    py=pr(:);
    davg=mean(py);dmax=max(py);dmin=min(py);
    HistData(:,n)=hist(py,0:2^RawBitNum-1);
    if WidthCentre>2^RawBitNum || WidthScale>2^RawBitNum || WidthCentre<=0 || WidthScale<=0
        tbegin=1;tend=2^RawBitNum;
    elseif WidthCentre>WidthScale
        if WidthCentre<=2^RawBitNum-WidthScale
            tbegin=WidthCentre-WidthScale;tend=WidthCentre+WidthScale;
        else
            tbegin=WidthCentre-WidthScale;tend=2^RawBitNum;
        end
    else
        if WidthCentre<=2^RawBitNum-WidthScale
            tbegin=1;tend=WidthCentre+WidthScale;
        else
            tbegin=1;tend=2^RawBitNum;
        end
    end
%    clear pt;
    pt(1:tend-tbegin+1)=HistData(tbegin:tend,n);
    m=tbegin:tend;
    bar(m,pt,1.0,drawcolor(n,1));
    title([drawtitle(n,1:size(drawtitle,2)),...
        '  ',num2str(dmax,'%5.0f'),'  ',num2str(dmin,'%5.0f'),'  ',...
        num2str(davg,'%5.0f'),'   W:',num2str(WhiteLevel,'%5.0f'),...
        '  B:',num2str(BlackLevel(n),'%5.0f')]);
    ver=max(pt)/2;
    hor=tbegin+(tend-tbegin)/2;
    text(hor,ver,drawfile,'horizontalAlignment', 'center',...
        'verticalAlignment', 'bottom');    
    grid on
end
save('rawconfig.mat','FigSequence','-append');
%--------------------------------------------------------------------------
end
%-------------------- Function Ending -------------------------------------