%--------------------------------------------------------------------------
% XZY => Lab
% change XYZ to CIE 1976(L*,a*,b*), or CIELAB
% CIE 1931 D50 - Xn=96.42;Yn=100;Zn=82.51;   
% CIE 1931 D65 - Xn=95.04;Yn=100;Zn=108.88;
%
% X,Y,Z => L*,a*,b*
% L* = 116 * f(Y/Yn) - 16;
% a* = 500 * [ f(X/Xn) - f(Y/Yn)];
% b* = 200 * [ f(Y/Yn) - f(Z/Zn)];
% if t>(6/29)^3, f(t)=t^(1/3)
% else f(t) = 1/3 * (29/6)^2 * t +16/116;
% 
% delta = 6/29;
% b = 16/116;
% a = 1/(3*delta^2);
% tzero = delta^3;
%
% L*,a*,b* => X,Y,Z
% fy = (L* +16)/116;
% fx = fy + a* /500;
% fz = fy - b* /200;
%
% if fy > delta, Y = Yn * fy^3;
% else Y = (fy - 16/116) * 3 * delta^2 * Yn;
%
% if fx > delta, X = Xn * fy^3;
% else X = (fx - 16/116) * 3 * delta^2 * Xn;
%
% if fz > delta, Z = Zn * fy^3;
% else Z = (fz - 16/116) * 3 * delta^2 * Zn;
%--------------------------------------------------------------------------
function ImageXyz=MatLab2Xyz(ImageLab)
%--------------------------------------------------------------------------
L=ImageLab(1,:);a=ImageLab(2,:);b=ImageLab(3,:);

%Xn=95.04;Yn=100;Zn=108.88; % D65, CIE 1931
% Xn=0.9504;Yn=1;Zn=1.0888; % D65, CIE 1931
%Xn=96.42;Yn=100;Zn=82.49;  % D50, Adobe Photoshop, ICC PCS & ProPhoto RGB
Xn=0.9642;Yn=1.0;Zn=0.8249; % D50, Adobe Photoshop, ICC PCS & ProPhoto RGB

delta=6/29;
bb=16/116;
dd=3*delta^2;
fy=(L+16)/116;
fx=fy+a/500;
fz=fy-b/200;

YL1=fy>delta;YL2=fy<=delta;
Y=Yn*power(fy,3).*double(YL1)+((fy-bb)*dd*Yn).*double(YL2);
XL1=fx>delta;XL2=fx<=delta;
X=Xn*power(fx,3).*double(XL1)+((fx-bb)*dd*Xn).*double(XL2);
ZL1=fz>delta;ZL2=fz<=delta;
Z=Zn*power(fz,3).*double(ZL1)+((fz-bb)*dd*Zn).*double(ZL2);

ImageXyz(1,:)=X;ImageXyz(2,:)=Y;ImageXyz(3,:)=Z;
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
