%--------------------------------------------------------------------------
% sRGB Gamma to Linear RGB
%--------------------------------------------------------------------------
function Y=MatLinear2Gamma(X,colorspace)
%--------------------------------------------------------------------------
X=max(X,0.0);X=min(X,1.0);
switch colorspace
    case 'sRGB'
        a=0.055;r=2.4;c=12.92;k=0.04045/c;
        Y=double(X>k).*((1+a)*X.^(1/r)-a)+double(X<=k).*(c*X);
        clear X;
    case 'Adobe RGB'
        r=2.19921875;
        Y=X.^(1/r);
        clear X;
    case 'ProPhoto RGB'
        k=16^(1.8/(1-1.8));
        Y=double(X>=k).*X.^(1/1.8)+double(X<k).*(X*16);
        clear X;
    otherwise
        disp('Unknown Color Space');
        INTERRUPT
end
Y=max(Y,0.0);Y=min(Y,1.0);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
