%--------------------------------------------------------------------------
function MatPhotoBrightCalibration(ToneCurve)
%--------------------------------------------------------------------------
Lab=[50;0;0];
Xyz=MatLab2Xyz(Lab);
Yn=Xyz(2,1);
N=length(ToneCurve);
Curve=reshape(ToneCurve,2,N/2);
x=Curve(1,:);
y=Curve(2,:);
delta=1.0e-6;
xi=0:delta:1.0;
yi=interp1(x,y,xi,'spline');
root=abs(yi(round(xi/delta)+1)-Yn);
[root,pi]=sort(root);
% save('rawdebug.mat','root','pi','-append');
Midgray=xi(pi(1));
Highlight=log2(1.0/Midgray);
Headroom=Highlight-log2(1/Yn);
Scal=2^Headroom*100;
PhotoBright.Headroom=Headroom;
PhotoBright.Highlight=Highlight;
PhotoBright.Scal=Scal;
PhotoBright.Midgray=Midgray;
save('rawdecode.mat','PhotoBright','-append');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
