%--------------------------------------------------------------------------
% BayerColorData Rescaleing, 
% Level Rescaling: BlackLevel => 0.0, WhiteLevel=>1.0
%--------------------------------------------------------------------------
function Photo=MatRescaling(Photo,BlackLevel,WhiteLevel)
%--------------------------------------------------------------------------
Photo=double(Photo);
[PhotoHeight,PhotoWidth,PhotoColor]=size(Photo);
if length(BlackLevel)~=1
    Black=BlackLevel;
else
    Black(1:PhotoColor)=BlackLevel;
end
if length(WhiteLevel)~=1
    White=WhiteLevel;
else
    White(1:PhotoColor)=WhiteLevel;
end
for n=1:PhotoColor
    Photo(:,:,n)=(1./(White(n)-Black(n))).*(Photo(:,:,n)-Black(n));
end
Photo=max(Photo,0.0);Photo=min(Photo,1.0);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
