%--------------------------------------------------------------------------
% Draw ImageRgb Chromaticity Diagram
%--------------------------------------------------------------------------
function MatRgbChromDiagram(ImageRgb,Apex,strTitle)
%--------------------------------------------------------------------------
% clear all;
% load('ImageRgb1.mat','ImageRgb1');
% ImageRgb=ImageRgb1;
% nfigure=3;
% Titlestring='ImageRgb1';
%--------------------------------------------------------------------------
load('rawconfig.mat','FigureShow','FigSequence');
if FigureShow==1
    rgbzone=[1,0,0,1;0,1,0,0;0,0,1,0];
    pixels=length(ImageRgb(1,:));
    rgb=GetChromCoord(ImageRgb);
    r=rgb(1,1:10:pixels);g=rgb(2,1:10:pixels);
    figure(FigSequence);
    FigSequence=FigSequence+1;
    plot(r,g,'.','color',[0.2,0.5,0.2]);
    hold on
    for n=1:length(Apex)
        apex=GetChromCoord(Apex(n).val);
        color=Apex(n).color;
        point=Apex(n).point;
        style=Apex(n).style;
        switch style
            case 1
                plot(apex(1,:),apex(2,:),'color',color);
            case 2
                plot(apex(1,:),apex(2,:),point,'color',color);
            otherwise
                plot(apex(1,:),apex(2,:),'color',color);
                plot(apex(1,:),apex(2,:),point,'color',color);
        end
    end
    plot(rgbzone(1,:),rgbzone(2,:),'color',[1,0,1]);
    plot(1/3,1/3,'s','color',[1,1,1]);
    hold off
    grid on
    title(strcat(strTitle,' - r,g Chromaticity Diagram'));
end
save('rawconfig.mat','FigSequence','-append');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
