%--------------------------------------------------------------------------
% Draw ImageXyz UCS Chromaticity Diagram
%--------------------------------------------------------------------------
function MatUcsChromDiagram(uvData,Apex,strTitle,recover)
%--------------------------------------------------------------------------
% clear all;
% load('ImageXyz.mat','ImageXyz');
% nfigure=1;Titlestring='ImageXyz';
%--------------------------------------------------------------------------
load('rawconfig.mat','FigureShow','FigSequence');
if FigureShow==1
    load('DataTable.mat','ChromDiagram','IlluminantTable','Coord_ProPhoto_RGB');
    D50=[0.9642;1;0.8249];
    d50=GetChromCoord(D50);
    [uD50,vD50]=xy2uv(d50(1,:),d50(2,:));
    
    figure(FigSequence)
    FigSequence=FigSequence+1;
    pixels=length(uvData(1,:));
    u=uvData(1,1:10:pixels);v=uvData(2,1:10:pixels);
    u=max(u,0);u=min(u,0.65);v=max(v,0);v=min(v,0.40);
    if recover==0
        plot(u,v,'.','color',[0.2,0.5,0.2]);
    else
        plot(IlluminantTable.u,IlluminantTable.v,'.','color',[0.0,0.1,0.8]);
    end
    hold on
    if recover~=0
        plot(u,v,'.','color',[0.2,0.5,0.2]);
    else
        plot(IlluminantTable.u,IlluminantTable.v,'.','color',[0.0,0.1,0.8]);
    end
    %--------------------------------------------------------------------------
    plot(ChromDiagram.u,ChromDiagram.v,'color',[0.7,0.7,0.7]);
    plot(Coord_ProPhoto_RGB.u,Coord_ProPhoto_RGB.v,'color',[1,0,1]);
    for n=1:length(Apex)
        uapex=Apex(n).val(1,:);
        vapex=Apex(n).val(2,:);
        color=Apex(n).color;
        point=Apex(n).point;
        style=Apex(n).style;
        switch style
            case 1
                plot(uapex,vapex,'color',color);
            case 2
                plot(uapex,vapex,point,'color',color);
            otherwise
                plot(uapex,vapex,'color',color);
                plot(uapex,vapex,point,'color',color);
        end
    end
    plot(uD50,vD50,'s','color',[1,1,1]);
    %--------------------------------------------------------------------------
    hold off
    grid on
    title(strcat(strTitle,' - UCS(u,v) Chromaticity Diagram'));
end
save('rawconfig.mat','FigSequence','-append');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
