%--------------------------------------------------------------------------
% CFA Data Rescaleing, 
% Level Rescaling: BlackLevel => 0.0, WhiteLevel=>1.0
%--------------------------------------------------------------------------
function CFA=MatWhiteBlackCalibration(CFA,BlackLevel,WhiteLevel)
%--------------------------------------------------------------------------
load('rawcamera.mat','Camera');
[Height,Width,Color]=size(CFA);
[h,w,c]=size(BlackLevel);
for n=1:Color
    Black=repmat(BlackLevel(:,:,n),Height/h,Width/w);
    CFA(:,:,n)=(1./(WhiteLevel(n)-Black)).*(CFA(:,:,n)-Black);
end
save('rawdecode.mat','BlackLevel','WhiteLevel','-append');
CFA=max(CFA,0);CFA=min(CFA,1.0);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
