%--------------------------------------------------------------------------
% XZY => Lab
% change XYZ to CIE 1976(L*,a*,b*), or CIELAB
% CIE 1931 D50 - Xn=96.42;Yn=100;Zn=82.51;   
% CIE 1931 D65 - Xn=95.04;Yn=100;Zn=108.88;
%
% X,Y,Z => L*,a*,b*
% L* = 116 * f(Y/Yn) - 16;
% a* = 500 * [ f(X/Xn) - f(Y/Yn)];
% b* = 200 * [ f(Y/Yn) - f(Z/Zn)];
% if t>(6/29)^3, f(t)=t^(1/3)
% else f(t) = 1/3 * (29/6)^2 * t +16/116;
% 
% delta = 6/29;
% b = 16/116;
% a = 1/(3*delta^2);
% tzero = delta^3;
%
% L*,a*,b* => X,Y,Z
% fy = (L* +16)/116;
% fx = fy + a* /500;
% fz = fy - b* /200;
%
% if fy > delta, Y = Yn * fy^3;
% else Y = (fy - 16/116) * 3 * delta^2 * Yn;
%
% if fx > delta, X = Xn * fy^3;
% else X = (fx - 16/116) * 3 * delta^2 * Xn;
%
% if fz > delta, Z = Zn * fy^3;
% else Z = (fz - 16/116) * 3 * delta^2 * Zn;
%--------------------------------------------------------------------------
function ImageLab=MatXyz2Lab(ImageXyz)
%--------------------------------------------------------------------------
X=ImageXyz(1,:);Y=ImageXyz(2,:);Z=ImageXyz(3,:);

%Xn=95.04;Yn=100;Zn=108.88; % D65, CIE 1931
%Xn=96.42;Yn=100;Zn=82.49;  % D50, Adobe Photoshop, ICC PCS & ProPhoto RGB
Xn=0.9642;Yn=1.0;Zn=0.8249; % Normalizition

tx=X./Xn;ty=Y./Yn;tz=Z./Zn;
aa=1/3*(29/6)^2;
bb=16/116;
cc=(6/29)^3;

XL1=tx>cc;XL2=tx<=cc;
fx=power(tx,1/3).*double(XL1)+(aa*tx+bb).*double(XL2);

YL1=ty>cc;YL2=ty<=cc;
fy=power(ty,1/3).*double(YL1)+(aa*ty+bb).*double(YL2);

ZL1=tz>cc;ZL2=tz<=cc;
fz=power(tz,1/3).*double(ZL1)+(aa*tz+bb).*double(ZL2);

L=116*fy-16;
a=500*(fx-fy);
b=200*(fy-fz);

ImageLab(1,:)=L;ImageLab(2,:)=a;ImageLab(3,:)=b;
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
