%--------------------------------------------------------------------------
% Draw ImageXyz Chromaticity Diagram
%--------------------------------------------------------------------------
function MatXyzChromDiagram(ImageXyz,Apex,strTitle)
%--------------------------------------------------------------------------
% clear all;
% load('ImageXyz.mat','ImageXyz');
% load('ApexRgb.mat','ApexRgb');
% fig=1;
% strTitle='ImageXyz';
% Apex.val=ApexRgb;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
%--------------------------------------------------------------------------
load('rawconfig.mat','FigureShow','FigSequence');
if FigureShow==1
    load('DataTable.mat','ChromDiagram','Coord_ProPhoto_RGB','Coord_sRGB');
    D50=[0.9642;1;0.8249];
    d50=GetChromCoord(D50);
    pixels=length(ImageXyz(1,:));
    xyz=GetChromCoord(ImageXyz);
    x=xyz(1,1:10:pixels);y=xyz(2,1:10:pixels);
    
    figure(FigSequence);
    FigSequence=FigSequence+1;
    plot(x,y,'.','color',[0.2,0.5,0.2]);
    hold on
    plot(ChromDiagram.x,ChromDiagram.y,'color',[0.7,0.7,0.7]);
    plot(Coord_ProPhoto_RGB.x,Coord_ProPhoto_RGB.y,'color',[1,0,1]);
    plot(Coord_sRGB.x,Coord_sRGB.y,'color',[0,1,1]);
    for n=1:length(Apex)
        apex=GetChromCoord(Apex(n).val);
        color=Apex(n).color;
        point=Apex(n).point;
        style=Apex(n).style;
        switch style
            case 1
                plot(apex(1,:),apex(2,:),'color',color);
            case 2
                plot(apex(1,:),apex(2,:),point,'color',color);
            otherwise
                plot(apex(1,:),apex(2,:),'color',color);
                plot(apex(1,:),apex(2,:),point,'color',color);
        end
    end
    plot(d50(1),d50(2),'s','color',[1,1,1]);
    hold off
    grid on
    title(strcat(strTitle,' - x,y Chromaticity Diagram'));
end
save('rawconfig.mat','FigSequence','-append');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
