%--------------------------------------------------------------------------
% Raw Expansion 
% Level Rescaling: BlackLevel => 0.0, WhiteLevel=>1.0
% BayerColorData(:,:,4) => PhotoData(:,:,3)
% PhotoData(:,:,3) => ImageData(3,:)
% Bayer Interpolation
%--------------------------------------------------------------------------
function Image=RawExpansion(PhotoRaw,Exposure)
%--------------------------------------------------------------------------
load('rawconfig.mat','PhotoRawSave','HighlightExpand');
if PhotoRawSave~=0
    disp('-------- Save Photo RAW Data --------');
    load('rawdecode.mat','FileName','UniqueCamera','CameraToXYZ',...
        'ISO','AsShotT','AsShotTint','WhiteBalance',...
        'ExposureBiasValue','RawBitNums','ExposureBaseline');
    load('rawconfig.mat','DataPath');
    DataPhotoFile=strcat(DataPath,strcat(strcat('Photo_',FileName),'.mat'));
    save(DataPhotoFile,'PhotoRaw','UniqueCamera','CameraToXYZ',...
        'ISO','AsShotT','AsShotTint','WhiteBalance',...
        'ExposureBiasValue','ExposureBaseline','RawBitNums');
end
Image=MatPhoto2Image(PhotoRaw);
clear PhotoRaw;
if HighlightExpand~=0
    load('rawdecode.mat','AsShotCameraNeutral');
    Image=MatHighlightExpand(Image,AsShotCameraNeutral);
end
Image=Image.*2^Exposure;
Image=max(Image,0.0);Image=min(Image,1.0);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
