%--------------------------------------------------------------------------
% XZY_D50 covert ProPoto RGB linear Calibration by Hsv Mapping Table
% than covert to XZY_D50
%--------------------------------------------------------------------------
function ImageXyz=RawProfileHsvCalibration(ImageXyz)
%--------------------------------------------------------------------------
load('rawdecode.mat','InterpCalibration','WeightFactor');
load('rawcamera.mat','Camera');
load('rawapex.mat','ApexRgb','ApexXyz','Apex');
H=1;S=2;V=3;
if isfield(Camera,'ProfileHueSatMapData1') && ...
        isfield(Camera,'ProfileHueSatMapDims')
    ImageRgb=RawSpaceXyz2Rgb(ImageXyz,'ProPhoto RGB');
    ImageRgb=min(ImageRgb,1.0);ImageRgb=max(ImageRgb,0.0);
    clear ImageXyz;
%--------------------------------------------------------------------------
    ApexRgb=RawSpaceXyz2Rgb(ApexXyz,'ProPhoto RGB');
    ApexRgb=min(ApexRgb,1.0);ApexRgb=max(ApexRgb,0.0);
    Apex.val=ApexRgb;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
    MatRgbChromDiagram(ImageRgb,Apex,'ImagRgb(D50)');
%--------------------------------------------------------------------------
    ProfileHsvCalibration=1;
    HsvCalibrationDims=Camera.ProfileHueSatMapDims;
    HueDivs=HsvCalibrationDims(H);
    SaturationDivs=HsvCalibrationDims(S);
    ValueDivs=HsvCalibrationDims(V);
    if InterpCalibration==1
        HsvCalibration1=reshape(Camera.ProfileHueSatMapData1,...
            3,HueDivs*SaturationDivs*ValueDivs);
        HsvCalibration2=reshape(Camera.ProfileHueSatMapData2,...
            3,HueDivs*SaturationDivs*ValueDivs);
        HsvCalibration=WeightFactor(1)*HsvCalibration1...
            +WeightFactor(2)*HsvCalibration2;
    else
        HsvCalibration=reshape(Camera.ProfileHueSatMapData1,...
            3,HueDivs*SaturationDivs*ValueDivs);
    end
    disp('3');
    ImageHsv=MatRgb2Hsv(ImageRgb);
    clear ImageRgb;
    disp('2');
    ImageHsv=MatHsvLookup(ImageHsv,HsvCalibration,...
        HueDivs,SaturationDivs,ValueDivs);
    disp('1');
    ImageRgb=MatHsv2Rgb(ImageHsv);
    clear ImageHsv;
    disp('0');
%--------------------------------------------------------------------------
    ApexHsv=MatRgb2Hsv(ApexRgb);
    ApexHsv=MatHsvLookup(ApexHsv,HsvCalibration,...
        HueDivs,SaturationDivs,ValueDivs);
    ApexRgb=MatHsv2Rgb(ApexHsv);
    ApexRgb=min(ApexRgb,1.0);ApexRgb=max(ApexRgb,0.0);
    Apex.val=ApexRgb;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
    MatRgbChromDiagram(ImageRgb,Apex,'ImagRgb HSV Calibration');
%--------------------------------------------------------------------------
    ImageXyz=RawSpaceRgb2Xyz(ImageRgb,'ProPhoto RGB');
    clear ImageRgb;
    save('rawdecode.mat','ProfileHsvCalibration',...
        'HsvCalibration','HsvCalibrationDims','-append');
%--------------------------------------------------------------------------
    ApexXyz=RawSpaceRgb2Xyz(ApexRgb,'ProPhoto RGB');
    Apex.val=ApexRgb;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
    MatXyzChromDiagram(ImageXyz,Apex,'ImageXyz(D50) after HSV Calibration');
    save('rawapex.mat','ApexRgb','ApexXyz','ApexHsv','Apex');
%--------------------------------------------------------------------------
else
    disp('------ ProfileHueSatMapData Not Found -------');
    ProfileHsvCalibration=0;
    save('rawdecode.mat','ProfileHsvCalibration','-append');
end
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
