%--------------------------------------------------------------------------
% XZY_D50 covert ProPoto RGB linear Calibration by Hsv Mapping Table
% than covert to XZY_D50
%--------------------------------------------------------------------------
function ImageRgb=RawProfileLookTable(ImageRgb)
%--------------------------------------------------------------------------
load('rawcamera.mat');
load('rawapex.mat','ApexRgb','ApexXyz','Apex');
H=1;S=2;V=3;
if isfield(Camera,'ProfileLookTableData') && ...
        isfield(Camera,'ProfileLookTableDims')
%--------------------------------------------------------------------------
    ApexRgb=RawSpaceXyz2Rgb(ApexXyz,'ProPhoto RGB');
    ApexRgb=min(ApexRgb,1.0);ApexRgb=max(ApexRgb,0.0);
    Apex.val=ApexRgb;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
    MatRgbChromDiagram(ImageRgb,Apex,'ImagRgb before Look Table');
%--------------------------------------------------------------------------
    ProfileLookTable=1;
    disp('-------- Found ProfileLookTableData --------');
    ProfileLookTableDims=Camera.ProfileLookTableDims;
    ProfileLookTableData=Camera.ProfileLookTableData;
    HueDivs=ProfileLookTableDims(H);
    SaturationDivs=ProfileLookTableDims(S);
    ValueDivs=ProfileLookTableDims(V);
    HuvLookTable=reshape(ProfileLookTableData,...
        3,HueDivs*SaturationDivs*ValueDivs);
    ImageRgb=min(ImageRgb,1.0);ImageRgb=max(ImageRgb,0.0);
    disp('3');
    ImageHsv=MatRgb2Hsv(ImageRgb);
    clear ImageRgb;
    disp('2');
    ImageHsv=MatHsvLookup(ImageHsv,HuvLookTable,...
        HueDivs,SaturationDivs,ValueDivs);
    disp('1');
    ImageRgb=MatHsv2Rgb(ImageHsv);
    clear ImageHsv;
    disp('0');
    save('rawdecode.mat','ProfileLookTable','ProfileLookTableDims',...
        'ProfileLookTableData','-append');
%--------------------------------------------------------------------------
    ApexHsv=MatRgb2Hsv(ApexRgb);
    ApexHsv=MatHsvLookup(ApexHsv,HuvLookTable,...
        HueDivs,SaturationDivs,ValueDivs);
    ApexRgb=MatHsv2Rgb(ApexHsv);
    ApexRgb=min(ApexRgb,1.0);ApexRgb=max(ApexRgb,0.0);
    Apex.val=ApexRgb;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
    MatRgbChromDiagram(ImageRgb,Apex,'ImagRgb after Look Table');
    save('rawapex.mat','ApexRgb','ApexXyz','ApexHsv','Apex');
%--------------------------------------------------------------------------
else
    disp('-------- ProfileLookTableData Not Found --------');
    ProfileLookTable=0;
    ImageRgb=ImageRgb;
    save('rawdecode.mat','ProfileLookTable','-append');
end
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
