%--------------------------------------------------------------------------
% ProfileToneCurve Calibration
%--------------------------------------------------------------------------
function ImageRgb=RawProfileToneCurve(ImageRgb)
%--------------------------------------------------------------------------
load('rawcamera.mat','Camera');
load('rawconfig.mat','FigSequence','ToneCurveShow');

if isfield(Camera,'ProfileToneCurve')
    disp('-------- Found ProfileToneCurve --------');
    ToneCurve=Camera.ProfileToneCurve;
    ImageRgb=max(ImageRgb,0.0);
    ImageRgb=min(ImageRgb,1.0);
    N=length(ToneCurve);
    Curve=reshape(ToneCurve,2,N/2);
    x=Curve(1,:);
    y=Curve(2,:);
    delta=1.0e-6;
    xi=0:delta:1.0;
    yi=interp1(x,y,xi,'spline');
    if ToneCurveShow~=0
        figure(FigSequence);
        FigSequence=FigSequence+1;
        plot(x,y,'o',xi,yi);
        title('Profile Tone Curve');
        save('rawconfig.mat','FigSequence','-append');
    end
    ImageRgb=yi(round(ImageRgb/delta)+1);
    ImageRgb=max(ImageRgb,0.0);
    ImageRgb=min(ImageRgb,1.0);
    MatPhotoBrightCalibration(ToneCurve);
    save('rawdecode.mat','ToneCurve','-append');
else
    disp('-------- ProfileToneCurve Not Found --------');
end
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
