%--------------------------------------------------------------------------
function [CFA,CameraNeutral]=RawReadImageData(DngFilePathName)
%--------------------------------------------------------------------------
disp('4');
warning('off','all');
RawInfo=imfinfo(strcat(DngFilePathName,'.dng'));
%--------------------------------------------------------------------------
load('rawdecode.mat','FileName');
RawCameraInfo(RawInfo,FileName);
load('rawcamera.mat','Camera');
%--------------------------------------------------------------------------
disp('3');
TiffHandle=Tiff(strcat(DngFilePathName,'.dng'),'r');
offsets=getTag(TiffHandle,'SubIFD');
setSubDirectory(TiffHandle,offsets(1));
CFA=double(read(TiffHandle));
close(TiffHandle);
warning('on','all');
UniqueCamera=Camera.UniqueCameraModel;
AsShotCameraNeutral=Camera.AsShotNeutral';
ISO=Camera.DigitalCamera.ISOSpeedRatings;
WhiteBalance=Camera.DigitalCamera.WhiteBalance;
ExposureBiasValue=Camera.DigitalCamera.ExposureBiasValue;
ExposureBaseline=Camera.BaselineExposure;
RawBitNums=floor(log2(Camera.WhiteLevel))+1;
save('rawdecode.mat','UniqueCamera','RawInfo','AsShotCameraNeutral',...
    'ISO','WhiteBalance','ExposureBiasValue','ExposureBaseline',...
    'RawBitNums','-append');
disp(UniqueCamera);
%--------------------------------------------------------------------------
disp('2');
SensorNeutral=[1;1;1];
[XyzNeutral,CameraToXYZ]=MatCameraToXYZ(SensorNeutral);
xyz=GetChromCoord(XyzNeutral);
[u,v]=xy2uv(xyz(1),xyz(2));
[SensorT,SensorTint]=GetColorTemperature(u,v);
save('rawdecode.mat','SensorT','SensorTint','-append');
%--------------------------------------------------------------------------
disp('1');
[AsShotXyzNeutral,CameraToXYZ]=MatCameraToXYZ(AsShotCameraNeutral);
CameraNeutral=AsShotCameraNeutral;
XyzNeutral=AsShotXyzNeutral;
xyz=GetChromCoord(AsShotXyzNeutral);
[u,v]=xy2uv(xyz(1),xyz(2));
[AsShotT,AsShotTint]=GetColorTemperature(u,v);
save('rawdecode.mat','AsShotXyzNeutral','CameraNeutral','XyzNeutral',...
    'AsShotT','AsShotTint','CameraToXYZ','-append');
disp('0');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
