%--------------------------------------------------------------------------
% Function: Camera color space to CIE XYZ
% ImageRgb(3,:) => ImageXyz(3,:)
%--------------------------------------------------------------------------
function ImageXyz=RawSpaceCameraToXyz_D50(ImageRawCamera,XyzNeutral)
%--------------------------------------------------------------------------
xyz=GetChromCoord(XyzNeutral);[u,v]=xy2uv(xyz(1),xyz(2));
[T,Tint]=GetColorTemperature(u,v);
%--------------------------------------------------------------------------
load('rawdecode.mat','AsShotCameraNeutral');
CameraToXYZ_D50=MatColorMapping(XyzNeutral);
XYZ_D50=CameraToXYZ_D50*AsShotCameraNeutral;
ImageXyz=CameraToXYZ_D50*ImageRawCamera;
clear ImageRawCamera;
save('rawdecode.mat','CameraToXYZ_D50','T','Tint','XYZ_D50','-append');
%--------------------------------------------------------------------------
ApexRgb=[AsShotCameraNeutral(1),0,0,AsShotCameraNeutral(1);...
        0,AsShotCameraNeutral(2),0,0;0,0,AsShotCameraNeutral(3),0];
ApexRgbStd=[1,0,0,1;0,1,0,0;0,0,1,0];
ApexRgb=ApexRgbStd;
ApexXyz=CameraToXYZ_D50*ApexRgb;
Apex.val=ApexXyz;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
MatXyzChromDiagram(ImageXyz,Apex,'ImageXyz(D50)');
save('rawapex.mat','ApexRgb','ApexXyz','Apex');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
