%--------------------------------------------------------------------------
% Function: [R;G;B] => [X;Y;Z;]
% ColorSpace: sRGB, Adobe_RGB, ProPhoto_RGB
% ImageRgb(3,:) => ImageXyz(3,:)
%--------------------------------------------------------------------------
function ImageXyz=RawSpaceRgb2Xyz(ImageRgb,ColorSpace)
%--------------------------------------------------------------------------
load('DataTable.mat',...
    'RGB2XYZ_sRGB','RGB2XYZ_Adobe_RGB','RGB2XYZ_ProPhoto_RGB');
% -------------------------------------------------------------------------
D50=[0.9642;1;0.8249];D65=[0.9504;1;1.0889];
switch ColorSpace
    case 'sRGB'
        Madapt=MatBradfordAlgorithm(D65,D50);
        RGB2XYZ=Madapt*RGB2XYZ_sRGB;
    case 'Adobe RGB'
        Madapt=MatBradfordAlgorithm(D65,D50);
        RGB2XYZ=Madapt*RGB2XYZ_Adobe_RGB;
    case 'ProPhoto RGB'
        RGB2XYZ=RGB2XYZ_ProPhoto_RGB;
    otherwise
        disp(ctrcat('Unknown color space - ',ColorSpace));
end
ImageXyz=RGB2XYZ*ImageRgb;
% -------------------------------------------------------------------------
end
% -------------------------------------------------------------------------
