%--------------------------------------------------------------------------
% Function: [X;Y;Z;] => [R;G;B]
% ColorSpace: sRGB, Adobe_RGB, ProPhoto_RGB
% ImageXyz(3,:) => ImageRgb(3,:)
%--------------------------------------------------------------------------
function ImageRgb=RawSpaceXyz2Rgb(ImageXyz,ColorSpace)
%--------------------------------------------------------------------------
load('DataTable.mat',...
    'XYZ2RGB_sRGB','XYZ2RGB_Adobe_RGB','XYZ2RGB_ProPhoto_RGB');
% -------------------------------------------------------------------------
D50=[0.9642;1;0.8249];D65=[0.9504;1;1.0889];
switch ColorSpace
    case 'sRGB'
        Madapt=MatBradfordAlgorithm(D50,D65);
        XYZ2RGB=XYZ2RGB_sRGB*Madapt;
    case 'Adobe RGB'
        Madapt=MatBradfordAlgorithm(D50,D65);
        XYZ2RGB=XYZ2RGB_Adobe_RGB*Madapt;
    case 'ProPhoto RGB'
        XYZ2RGB=XYZ2RGB_ProPhoto_RGB;
    otherwise
        disp(strcat('Unknown color space - ',ColorSpace));
end
ImageRgb=XYZ2RGB*ImageXyz;
% -------------------------------------------------------------------------
end
% -------------------------------------------------------------------------
